#ifndef TMESH_H_
#define TMESH_H_

#include "phc.h"
#include "frameBuffer.h"

class TMesh {

  V3 *verts;
  int vertsN;
  unsigned int *tris;
  int trisN;
  unsigned int color;
  V3 *litVerts;
  V3 *normals;
public:
  TMesh();
  TMesh(char shape);
  void Allocate();
  void Load(char *fileName);
  void RenderWF(FrameBuffer *fb, PHC *phc);
  void RenderFM(FrameBuffer *fb, PHC *phc);
  V3 FindCenter();
  float FindDiagonal();
  void ScaleToMaxDim(float maxDim);
  void TranslateBy(V3 translationVector);
  void ScaleBy(float scf);
  void TranslateTo(V3 newCenter);
  void SetColor(unsigned int col) {color = col;};
  void Light(V3 lightVector);
  void ComputeNormals();
  bool BackFacing(int tri, PHC *phc);
};

#endif